/*
 * any2fdif.c
 *
 * 040602 created as a HTML to MAIL converter
 * 040609 extended to a FDIF generator taking generic input types
 *
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <arpa/inet.h> /* for htonl() */

extern char *RFC822_fgetsHeaderField();
extern char *wordscanX();
extern char *valuescanX();
extern char *scanAttr();
extern char *mbstrcpy();
extern scanMeta();
extern fscanTag();
extern char *strskip();
extern int scanNNTPtime();
extern void *newMD5();
extern char *malloc();

VSocket(){}
fullpathSUCOM(){}
BeforeExec(){}

static char *ccx_outcode = "a-r-EUC-JP";

extern MIME_rewaddrs();
static char *hide_addr = "From:%l@%r..%c";

#define T_TEXT	1
#define T_MAIL	2
#define T_HTML	3
#define T_HTTP	4

static int Itype = T_HTML;
static int opt_v = 0;

static scanUrls(flist,pre,out,descf)
	FILE *flist;
	char *pre;
	FILE *out,*descf;
{	char url[1024],*dp;
	char buff[0x10000];
	FILE *in;

	while( fgets(url,sizeof(url),flist) != NULL ){
		if( dp = strpbrk(url,"\r\n") )
			*dp = 0;
		if( in = fopen(url,"r") ){
			any2fdif(pre,url,in,out,descf);
			fclose(in);
		}
	}
}

static FILE *Out;
static FILE *Descf;

static makedir(dir)
	char *dir;
{
	if( File_is(dir) ){
		if( File_isreg(dir) ){
			fprintf(stderr,"Is flat file: %s\n",dir);
			exit(-1);
		}
	}else{
		if( mkdir(dir,0750) != 0 ){
			fprintf(stderr,"Can't create: %s\n",dir);
			exit(-1);
		}
	}
}
static scanFilelist(outname,outmode,pre,flist)
	char *outname,*outmode,*pre;
	FILE *flist;
{	char outdir[1024],path[1024],*dp,*dbname,outnameb[1024];

	if( strcmp(outname,"-") == 0 ){
		Out = stdout;
		Descf = stderr;
	}else{
		if( strtailchr(outname) == '/' ){
			strcpy(outdir,outname);
			outdir[strlen(outdir)-1] = 0;
			makedir(outdir);
			if( dp = strrchr(outdir,'/') ){
				dbname = dp+1;
			}else	dbname = outdir;
			sprintf(outnameb,"%s/%s",outdir,dbname);
			outname = outnameb;
		}
		sprintf(path,"%s.fdif",outname);
		Out = fopen(path,outmode);

		sprintf(path,"%s.dsc",outname);
		Descf = fopen(path,outmode);
	}
	if( Out == NULL || Descf == NULL ){
		fprintf(stderr,"Error: %s\n",outname);
		exit(-1);
	}
	scanUrls(flist,pre,Out,Descf);
}

static usage(ac,av,code)
	char *av[];
{
	fprintf(stderr,
	"Usage: %s [-v] -o indexname[/] [-p urlprefix] [-f[hmtH] listfile]*\n",
		av[0]);
	exit(code);
}
main(ac,av)
	char *av[];
{	int ai;
	char *a1;
	char *outname = "/tmp/frsx";
	char *outmode = "w";
	char *pre = "";
	FILE *in = stdin;
	FILE *flist = NULL;
	FILE *tmp;

	if( ac < 2 )
		usage(ac,av,-1);

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( strcmp(a1,"-v") == 0 ){
			opt_v = 1;
		}else
		if( strcmp(a1,"-o") == 0 || strcmp(a1,"-a") == 0 ){
			if( ai+1 < ac ){
				outname = av[++ai];
				outmode = strcmp(a1,"-o")==0 ? "w" : "a";
			}
		}else
		if( strcmp(a1,"-p") == 0 ){
			if( ai+1 < ac )
				pre = av[++ai];
		}
	}
	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( strcmp(a1,"-v") == 0 ){
		}else
		if( strcmp(a1,"-o") == 0 ){
			if( ai+1 < ac ){
				++ai;
			}
		}else
		if( strncmp(a1,"-f",2) == 0 ){
			switch(a1[2]){
				case 't': Itype = T_TEXT; break;
				case 'm': Itype = T_MAIL; break;
				case 'h': Itype = T_HTML; break;
			}
			if( ai+1 < ac ){
				if( strcmp(av[++ai],"-") == 0 )
					flist = stdin;
				else	flist = fopen(av[ai],"r");
				if( flist == NULL ){
					fprintf(stderr,"Error: %s\n",av[ai]);
					exit(-1);
				}
				scanFilelist(outname,outmode,pre,flist);
			}
		}else
		if( strcmp(a1,"-p") == 0 ){
			if( ai+1 < ac )
				pre = av[++ai];
		}else{
			if( in = fopen(a1,"r") ){
				any2fdif(pre,a1,in,Out,Descf);
				fclose(in);
			}
		}
	}
}

static int Mtime;
static int Fsize;
static char Url[1024] = "";
static char Descr[1024] = "";
static char Keywd[1024] = "";
static char Title[1024] = "";
static char Heads[1024] = "";
static char Author[1024] = "(unknown)";
static int Ccx[32];

static encEnt(md5,out,tag,attr,buf)
	void *md5;
	FILE *out;
	char *tag,*attr,*buf;
{	char outb[2048];

	addMD5(md5,buf,strlen(buf));
	addMD5(md5,"",1);

	encodeEntitiesX(buf,outb,sizeof(outb));
	fprintf(out,"<%s",tag);
	if( *attr ) fprintf(out," %s",attr);
	fprintf(out,">\n%s\n</%s>\n",outb,tag);
}

#define DESCBLOCKSIZE	256
typedef struct {
	int	d_size;
	int	d_date;
	int	d_lastmod;
	char	d_url[DESCBLOCKSIZE-(3*sizeof(int))];
	/*
	char	d_author[];
	char	d_title[];
	char	d_digest[];
	*/
} DescRecord;
static makeDesc(Desc,fsize,mtime,digest)
	DescRecord *Desc;
	char *digest;
{	int rsiz,ulen,alen,tlen,dlen;
	char *dp;

	Desc->d_size = htonl(fsize);
	Desc->d_date = 0;
	Desc->d_lastmod = htonl(mtime);

	rsiz = sizeof(DescRecord) - ((int)&Desc->d_url - (int)Desc);
	ulen = strlen(Url) + 1; 
	alen = strlen(Author) + 1; 
	tlen = strlen(Title) + 1; 
	dlen = strlen(digest) + 1; 
	if( rsiz < ulen+alen+tlen+dlen )
		if( 120 < ulen ) ulen = 120;
	if( rsiz < ulen+alen+tlen+dlen )
		if( 40 < alen ) alen = 40;
	if( rsiz < ulen+alen+tlen+dlen )
		if( 80 < tlen ) tlen = 80;
	if( rsiz < ulen+alen+tlen+dlen )
		dlen = rsiz - (ulen+alen+tlen);
	dp = Desc->d_url;
	dp = mbstrcpy(dp,Url,ulen);
	dp = mbstrcpy(dp,Author,alen);
	dp = mbstrcpy(dp,Title,tlen);
	dp = mbstrcpy(dp,digest,dlen);
}
static skipLine(line)
	char *line;
{	char *dp,ch;

	if( strncasecmp(line,"-----BEGIN",10)==0 )
		return 3;

	if( strncasecmp(line,"In message",10)==0
	 || strncasecmp(line,"In article",10)==0
	 || strncasecmp(line,"In <",4)==0
	 || strncasecmp(line,"On ",3)==0 && (
		   strstr(line,"wrote")
		|| strstr(line,")\n")
		|| strstr(line,">\n")
	    )
	 || ((dp = strskip(line,"wrote"  )) && strstr(dp,">\n"))
	 || ((dp = strskip(line,"said:"  )) && (*dp==' '||*dp=='\n'))
	 || ((dp = strskip(line,"wrote:" )) && (*dp==' '||*dp=='\n'))
	 || ((dp = strskip(line,"writes:")) && (*dp==' '||*dp=='\n'))
	)
		return 1;

	if( line[0] == '>'
	 || line[0] == '|'
	 || strncmp(line," >",2) == 0
	 || strncmp(line," |",2) == 0
	)
		return 1;

	for( dp = line; ch = *dp; dp++ ){
		if( !isalnum(ch) && !isspace(ch)
		 && ch != '.' && ch != '-' && ch != '_' )
			break;
	}
	if( *dp == '>' )
		return 1;

	return 0;
}

static FILE *Tmps[3];
#define Tmp0	Tmps[0]
#define Tmp1	Tmps[1]
#define Tmp2	Tmps[2]
static FILE *getTmp(ti)
{
	if( Tmps[ti] == NULL )
		Tmps[ti] = tmpfile();
	else{
		clearerr(Tmps[ti]);
		fseek(Tmps[ti],0,0);
	}
	return Tmps[ti];
}
static fflushtrunc(fp)
	FILE *fp;
{
	fflush(fp);
	ftruncate(fileno(fp),(off_t)ftell(fp));
	fseek(fp,0,0);
}

any2fdif(pre,path,in,out,descf)
	char *pre,*path;
	FILE *in,*out,*descf;
{	char date[64];
	struct tm *tm; int ch,issp,wassp;
	char inb[1024],outb[1024],*ip,*op;
	char digest[256],*dp,*dx;
	DescRecord Desc;
	int skip,skiphead;
	void *md5;
	char MD5digest[32],md5a[64];

	Mtime = file_mtime(fileno(in));
	Fsize = file_size(fileno(in));
	if( opt_v ){
		fprintf(stderr,"[%s%s]\r\n",pre,path);
	}
	sprintf(Url,"%s%s",pre,path);
	Title[0] = 0;
	Descr[0] = 0;
	Heads[0] = 0;

	CCXcreate("*",ccx_outcode,Ccx);

	if( Itype == T_HTML ){
		Tmp0 = getTmp(0);
		while( fgets(inb,sizeof(inb),in) != NULL ){
			CCXexec(Ccx,inb,strlen(inb),outb,sizeof(outb));
			fputs(outb,Tmp0);
		}
		fflushtrunc(Tmp0);
		in = Tmp0;
	}
	Tmp1 = getTmp(1);
	switch( Itype ){
		case T_HTML: scanHtml(in,Tmp1); break;
		case T_MAIL: scanMail(in,Tmp1); break;
	}
	fflushtrunc(Tmp1);

	md5 = newMD5();
	addMD5(md5,path,strlen(path));
	addMD5(md5,"",1);

	fprintf(out,"<DOC HREF=\"%s%s\">\n",pre,path);
	encEnt(md5,out,"TITLE","",Title);
	encEnt(md5,out,"AUTHOR","",Author);
	if( Keywd[0] ) encEnt(md5,out,"KEYWORD","",Keywd);
	if( Descr[0] ) encEnt(md5,out,"TEXT","WEIGHT=\"1\"",Descr);
	if( Heads[0] ) encEnt(md5,out,"TEXT","WEIGHT=\"2\"",Heads);
	fprintf(out,"<TEXT WEIGHT=\"3\">\n");

	dp = digest;
	dx = digest + (sizeof(digest)-1);
	skiphead = 0;
	while( fgets(inb,sizeof(inb),Tmp1) != NULL ){
		for( ip = inb; ch = *ip; ip++ ){
			if( isspace(ch) && ch != '\n' )
				*ip = ' ';
		}
		addMD5(md5,inb,strlen(inb));
		encodeEntitiesX(inb,outb,sizeof(outb));
		fputs(outb,out);

		if( skiphead ){
			if( inb[0] == '\r' || inb[0] == '\n' )
				skiphead = 0;
		}else
		if( skiphead == 0 && dp < dx ){
			skip = skipLine(inb);
			skiphead = skip & 2;
			if( skip == 0 ){
				wassp = 1;
				for( ip = inb; ch = *ip; ip++ ){
					if( dx <= dp )
						break;
					if( issp = isspace(ch) )
						ch = ' ';
					if( !(wassp && issp) )
						*dp++ = ch;
					wassp = issp;
				}
			}
		}
	}
	*dp = 0;

	fprintf(out,"</TEXT>\n");
	fprintf(out,"</DOC>\n");

	endMD5(md5,MD5digest);
	MD5toa(MD5digest,md5a);
/*
printf("%s\n",md5a);
*/

	makeDesc(&Desc,Fsize,Mtime,digest);
	fwrite(&Desc,1,sizeof(Desc),descf);
}

scanMail(in,out)
	FILE *in,*out;
{	char line[1024],xline[1024],fnam[32],fval[1024],yline[1024];
	int li;
	int inUU;

	while( RFC822_fgetsHeaderField(line,sizeof(line),in) != NULL ){
		if( *line == '\r' || *line == '\n' )
			break;

		scan_field1(line,fnam,sizeof(fnam),fval,sizeof(fval));
		if( strcaseeq(fnam,"Content-Type") ){
			if( strncaseeq(fval,"multipart/",10) ){
				Tmp2 = getTmp(2);
				fseek(in,0,0);
				PGPdecodeMIME(in,Tmp2,NULL,0x2FF,0,0);
				fflushtrunc(Tmp2);
				scanMail(Tmp2,out);
				return;
			}
		}else
		if( strcaseeq(fnam,"Subject")
		 || strcaseeq(fnam,"From") ){
			if( hide_addr )
				MIME_rewaddrs(hide_addr,line);
			MIME_strHeaderDecode(line,xline,sizeof(xline));
			CCXexec(Ccx,xline,strlen(xline),yline,sizeof(yline));
			scan_field1(yline,fnam,sizeof(fnam),fval,sizeof(fval));
		}
		if( strcaseeq(fnam,"Subject") ){
			linescanX(fval,Title,sizeof(Title));
		}else
		if( strcaseeq(fnam,"From") ){
			linescanX(fval,Author,sizeof(Author));
		}else
		if( strcaseeq(fnam,"Date") ){
			Mtime = scanNNTPtime(fval);
		}
	}
	inUU = 0;
	for( li = 0; fgets(xline,sizeof(xline),in) != NULL; li++ ){
		if( inUU == 0 ){
			if( strncmp(xline,"begin ",6) == 0 )
			if( isdigit(xline[6]) )
			{
				inUU = 1;
				continue;
			}
		}else{
			if( strncmp(xline,"end",3) == 0 ){
				inUU = 0;
				continue;
			}
		}
		CCXexec(Ccx,xline,strlen(xline),yline,sizeof(yline));
		fputs(yline,out);
	}
}
scanHtml(in,tmp)
	FILE *in,*tmp;
{	int ch,pch,end;
	char *dp,tag[0x10000],tagn[32],attrn[32];
	char nam[32],con[1024];
	int inTitle = 0;
	int inScript = 0;
	int inHeads = 0;
	int preisspace = 0;
	char *tip = Title,*tix = Title+(sizeof(Title)-1);
	char *htp = Heads,*htx = Heads+(sizeof(Heads)-1);

	pch = 0;
	while( (ch = getc(in)) != EOF ){
	    if( ch == '<' ){
		ch = getc(in);
		if( ch == EOF )
			break;
		if( ch == '!' ){
			if( skipComment(in) == EOF )
				break;
			else	continue;
		}

		if( end = (ch == '/') ){
			ch = getc(in);
		}else{
		}
		fscanTag(in,ch,tag,sizeof(tag));

		dp = wordscanX(tag,tagn,sizeof(tagn));
		if( strcasecmp(tagn,"SCRIPT") == 0 )
			inScript += end ? 1 : -1;
		else
		if( strcasecmp(tagn,"TITLE") == 0 )
			inTitle += end ? 1 : -1;
		else
		if( (tagn[0]=='H' || tagn[0]=='h') && isdigit(tagn[1]) ){
			if( !end && htp != Heads && htp < htx )
				*htp++ = ',';
			inHeads = end ? 0 : atoi(tag+1);
		}else
		if( strcasecmp(tagn,"META") == 0 ){
			if( scanMeta(dp,nam,sizeof(nam),con,sizeof(con) ) == 0 )
			if( strcasecmp(nam,"DESCRIPTION") == 0 )
				Strncpy(Descr,con,sizeof(Descr));
			if( strcasecmp(nam,"KEYWORDS") == 0 )
				Strncpy(Keywd,con,sizeof(Keywd));
		}
	    }else
	    if( ch == '&' ){
		ch = getc(in);
		while( ch != EOF && isalpha(ch) ){
			ch = getc(in);
		}
		if( ch != ';' )
			ungetc(ch,in);
	    }else{
		if( isspace(ch) && preisspace ){
		}else{
			preisspace = isspace(ch);
			if( inTitle ){
				if( tip < tix )
				if( ch != '\n' && ch != '\r' )
					*tip++ = ch;
				continue;
			}
			if( inHeads ){
				if( htp < htx )
				if( ch != '\n' && ch != '\r' )
					*htp++ = ch;
			}
			if( !(isspace(ch) && isspace(pch)) )
				putc(ch,tmp);
			pch = ch;
		}
	    }
	}
	*tip = 0;
}

char *scanAttr(src,nam,val,vsiz)
	char *src,*nam,*val;
{	char *dp;

	dp = src;
	while( isspace(*dp) ) dp++;
	if( strncasecmp(dp,nam,strlen(nam)) == 0 ){
		dp += strlen(nam);
		while( isspace(*dp) ) dp++;
		if( *dp == '=' ){
			dp++;
			while( isspace(*dp) ) dp++;
			dp = valuescanX(dp,val,vsiz);
			while( isspace(*dp) ) dp++;
			return dp;
		}
	}
	return NULL;
}
scanMeta(src,nam,nsiz,con,csiz)
	char *src,*nam,*con;
{	char *dp;

	dp = src;
	if( dp = scanAttr(dp,"NAME",nam,nsiz) )
	if( dp = scanAttr(dp,"CONTENT",con,csiz) )
		return 0;
	return -1;
}
fscanTag(in,ch,tag,tsiz)
	FILE *in;
	char *tag;
{	char *tp,*tx,quote;
	int pch = 0;

	quote = 0;
	tp = tag;
	tx = tag + (tsiz-1);
	while( tp < tx && ch !=EOF ){
		if( ch == '\'' || ch == '"' ){
			if( quote && quote != ch ){
			}else
			if( quote == 0 )
				quote = ch;
			else	quote = 0;
		}
		if( quote == 0 && ch == '>' )
			break;

		if( ch == '\n' || ch == '\r' )
			ch = ' ';
		if( !(isspace(ch) && isspace(pch)) )
			*tp++ = ch;
		pch = ch;
		ch = getc(in);
	}
	*tp = 0;
}
skipComment(in)
	FILE *in;
{	int ch,pch,comlev;

	pch = -1;
	comlev = 1;
	while( (ch = getc(in)) != EOF ){
		if( ch == '<' ){
			comlev++;
		}else
		if( ch == '>' ){
			comlev--;
			if( comlev == 0 )
				break;
		}
		pch = ch;
	}
	return ch;
}
char *mbstrcpy(dst,src,len)
	char *dst,*src;
{	char *dp,*sp,ch;
	int lx,in2B;

	dp = dst;
	in2B = 0;
	lx = 1;
	for( sp = src; lx < len && (ch = *sp); sp++ ){
		*dp++ = ch;
		lx++;
		if( in2B == 0 ){
			if( ch & 0x80 )
				in2B = 1;
		}else{
			in2B = 0;
		}
	}
	if( in2B ){
		dp--;
	}
	*dp++ = 0;
	return dp;
}
char *strskip(s,p)
	char *s,*p;
{	char *t;

	if( t = strstr(s,p) )
		return t + strlen(p);
	else	return 0;
}
